<?php
twitter_it_admin::init();

class twitter_it_admin {

	function init()
	{
		add_action('admin_menu', array('twitter_it_admin', 'admin_menu'));
	}

	function update_options()
	{
		$options = $_POST['twitter_it'];
		$options[button] = isset($options[button]);
		$options[nofollow] = isset($options[nofollow]);

		update_option('twitter_it_params', $options);
	}

	function admin_menu()
	{
		add_options_page(
				__('Twitter It!'),
				__('Twitter It!'),
				'manage_options',
				__FILE__,
				array('twitter_it_admin', 'admin_page')
				);
	}
	
	function admin_page()
	{

		if ( isset($_POST['update_twitter_it_options'])
			&& $_POST['update_twitter_it_options']
			)
		{
			twitter_it_admin::update_options();

			echo "<div class=\"updated\">\n"
				. "<p>"
					. "<strong>"
					. __('Settings saved.')
					. "</strong>"
				. "</p>\n"
				. "</div>\n";
		}

		$options = get_option('twitter_it_params');

		echo "<div class=\"wrap\">\n"
			. "<h2>" . __('Twitter It! Settings') . "</h2>\n"
			. "<form method=\"post\" action=\"\">\n";

		if ( function_exists('wp_nonce_field') ) wp_nonce_field('twitter_it');

		echo '<input type="hidden" name="update_twitter_it_options" value="1">';

		echo '<table class="form-table">';

		echo '<tr>'
			. '<td>'
			. '<label for="twitter_it[label]">'
			. '<input type="text"'
				. ' name="twitter_it[label]" id="twitter_it[label]" value="'.$options['label'].'"'
				. ' />'
			. '&nbsp;'
			. __('Label for the Twitter It! Button')
			. '</label>'
			. '</td>'
			. '</tr>';
			
		echo '<tr>'
			. '<td>'
			. '<label for="twitter_it[button]">'
			. '<input type="checkbox"'
				. ' name="twitter_it[button]" id="twitter_it[button]"'
				. ( $options['button'] ? ' checked="checked"' : '' )
				. ' />'
			. '&nbsp;'
			. __('Show Twitter-Image next to text?')
			. '</label>'
			. '</td>'
			. '</tr>';	
			
		echo '<tr>'
			. '<td>'
			. '<label for="twitter_it[style]">'
			. '<input type="text"'
				. ' name="twitter_it[style]" id="twitter_it[style]" value="'.$options['style'].'"'
				. ' />'
			. '&nbsp;'
			. __('Add custom CSS style?')
			. '</label>'
			. '</td>'
			. '</tr>';	
			
		echo '<tr>'
			. '<td>'
			. '<label for="twitter_it[prefix]">'
			. '<input type="text"'
				. ' name="twitter_it[prefix]" id="twitter_it[prefix]" value="'.$options['prefix'].'"'
				. ' />'
			. '&nbsp;'
			. __('Prefix for the twitter-message e.g. "Reading" and so on...')
			. '</label>'
			. '</td>'
			. '</tr>';	
			
		echo '<tr>'
			. '<td>'
			. '<label for="twitter_it[nofollow]">'
			. '<input type="checkbox"'
				. ' name="twitter_it[nofollow]" id="twitter_it[nofollow]"'
				. ( $options['nofollow'] ? ' checked="checked"' : '' )				
				. ' />'
			. '&nbsp;'
			. __('Mark the twitter-link as nofollow? (Better for search-engines)')
			. '</label>'
			. '</td>'
			. '</tr>';				
						
			
		echo '</table>';

		echo '<p class="submit">'
			. '<input type="submit"'
				. ' value="' . attribute_escape(__('Save Changes')) . '"'
				. ' />'
			. '</p>';

		echo '</form>'
			. '</div>';
	}
}
?>