<?php
/*
Plugin Name: Twitter It!
Plugin URI: http://roman-allenstein.de/wordpress
Description: Let your visitors twitter your posts over the web! Activate the plugin an integrate the following code into your Template. <code>&lt;?php if ( function_exists('twitter_it') ) : twitter_it($post->ID); endif; ?></code>
Version: 3.1
Author: Roman Allenstein
Author URI: http://roman-allenstein.de
*/
/*  Copyright 2009  Roman Allenstein  (email : wordpress@roman-allenstein.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/
function twitter_it($id) {
  twitter_it::the_twitter_tag($id);
}

class twitter_it {
  
  const TABLE_NAME  = "twitter_it_tinyurls";
  const TWITTER_API = "http://tinyurl.com/api-create.php?url=";
  const VERSION     = "2";
  const MESSAGE_LENGTH = 140;

	function init()
	{
		$options = twitter_it::get_options();      
    if($options[button]) {
      add_action('wp_head', array('twitter_it', 'add_css'));
    }
	}
	
	
	function get_options()
	{
		if ( ( $o = get_option('twitter_it_params') ) === false )
		{
			$o = array(
				'label' => "Twitter It!",
				'prefix' => "Reading ",
				'button' => false
				);
			
			update_option('twitter_it_params', $o);
		}
		
		return $o;
	}
	
	
  function the_twitter_tag($id) 
  {
    $options = twitter_it::get_options();
  
    $p = get_post($id);
    
    if($options[button]) {
      $class = 'class="post-twitter" ';
    }
    
    if($options[nofollow]) {
      $rel = 'rel="nofollow"';
    }    
  
    if($options[style]) {
      $style = 'style="'.$options[style].'"';
    }  
  
    $string  = '<span '.$class.''.$style.'>';  
  
    $string .= '<a href="'.twitter_it::generate_twitter_link($p->post_title, $p->guid).'" title="'.$options[label].'" '.$rel.'>'.$options[label].'</a>';
  
    $string  .= '</span>'; 
    echo $string;
  }

  function generate_twitter_link($title, $post_url) {
    global $wpdb;
    $options = twitter_it::get_options();
    
    if($wpdb->get_var("SELECT COUNT(*) FROM " . $wpdb->prefix . twitter_it::TABLE_NAME . " WHERE post_url = '" . $post_url . "'") == 0) {
      $tiny_url = twitter_it::generate_short_url($post_url);
      $sql = "INSERT INTO " . $wpdb->prefix . twitter_it::TABLE_NAME . "(post_url, tiny_url) VALUES ('$post_url', '$tiny_url')";
      $results = $wpdb->query($sql);
    } else {
      $tiny_url = $wpdb->get_var("SELECT tiny_url FROM " . $wpdb->prefix . twitter_it::TABLE_NAME . " WHERE post_url = '" . $post_url . "'");
    }
    
    $twitterTitle = rawurlencode($options[prefix] . " \"".$title."\" " . $tiny_url);
    
    $prefix_length = strlen($options[prefix]);
    $suffix_length = strlen($tiny_url);
    $twitit_length    = twitter_it::MESSAGE_LENGTH - $prefix_length - $suffix_length;
    
    if(strlen($twitterTitle) > $twitit_length) {
      $twitterTitle = rawurlencode($options[prefix] . " \"".trim(substr($title,0,($twitit_length-4-3)))."\" " . $tiny_url);
    }
    
    
    $twitterLink = "http://twitter.com/home?status=".$twitterTitle;
    return $twitterLink;
  }
  
  function generate_short_url($url) {
    $shortUrl = file_get_contents(twitter_it::TWITTER_API . $url);
    return $shortUrl;
  }

  function add_css() {
    echo '<link rel="stylesheet" href="'.get_bloginfo('wpurl').'/wp-content/plugins/twitter_it/css/twitter_it.css" type="text/css" media="screen" />';
  }
}
twitter_it::init();

# include admin stuff when relevant
if ( is_admin() )
{
	include dirname(__FILE__) . '/twitter_it-admin.php';
}

# Installer
function twitter_it_install () {
  $action = 'install';
	require_once(dirname(__FILE__).'/installer.php');
}
register_activation_hook(__FILE__,'twitter_it_install');
?>